# Ogre::AtomicObject< T > Class Template Reference

`#include <OgreAtomicWrappers.h>`

List of all members.

## Public Member Functions

| AtomicObject (const T &initial)
| AtomicObject (const AtomicObject< T > &cousin)
| AtomicObject ()
void | operator= (const AtomicObject< T > &cousin)
T | get (void) const
void | set (const T &v)
bool | cas (const T &old, const T &nu)
T | operator++ (void)
T | operator++ (int)
T | operator-- (int)

## Protected Attributes

OGRE_AUTO_MUTEX volatile T | mField

## Detailed Description

### template<class T>
class Ogre::AtomicObject< T >

Definition at line 38 of file OgreAtomicWrappers.h.

## Constructor & Destructor Documentation

template<class T>

Ogre::AtomicObject< T >::AtomicObject | ( | const T & | initial | ) |

Definition at line 42 of file OgreAtomicWrappers.h.

template<class T>

Ogre::AtomicObject< T >::AtomicObject | ( | const AtomicObject< T > & | cousin | ) |

Definition at line 46 of file OgreAtomicWrappers.h.

template<class T>

Ogre::AtomicObject< T >::AtomicObject | ( |  | ) |

Definition at line 50 of file OgreAtomicWrappers.h.

## Member Function Documentation

template<class T>

void Ogre::AtomicObject< T >::operator= | ( | const AtomicObject< T > & | cousin | ) |

Definition at line 53 of file OgreAtomicWrappers.h.

References Ogre::AtomicObject< T >::get().

template<class T>

T Ogre::AtomicObject< T >::get | ( | void |  | ) | const

Definition at line 58 of file OgreAtomicWrappers.h.

References Ogre::AtomicObject< T >::mField, and OGRE_LOCK_AUTO_MUTEX.

Referenced by Ogre::AtomicObject< T >::operator=().

template<class T>

void Ogre::AtomicObject< T >::set | ( | const T & | v | ) |

Definition at line 64 of file OgreAtomicWrappers.h.

References Ogre::AtomicObject< T >::mField, and OGRE_LOCK_AUTO_MUTEX.

template<class T>

bool Ogre::AtomicObject< T >::cas | ( | const T & | old,
|  | const T & | nu |
| ) |  |  |

Definition at line 70 of file OgreAtomicWrappers.h.

References Ogre::AtomicObject< T >::mField, and OGRE_LOCK_AUTO_MUTEX.

template<class T>

T Ogre::AtomicObject< T >::operator++ | ( | void |  | ) |

Definition at line 78 of file OgreAtomicWrappers.h.

References Ogre::AtomicObject< T >::mField, and OGRE_LOCK_AUTO_MUTEX.

template<class T>

T Ogre::AtomicObject< T >::operator++ | ( | int |  | ) |

Definition at line 84 of file OgreAtomicWrappers.h.

References Ogre::AtomicObject< T >::mField, and OGRE_LOCK_AUTO_MUTEX.

template<class T>

T Ogre::AtomicObject< T >::operator-- | ( | int |  | ) |

Definition at line 90 of file OgreAtomicWrappers.h.

References Ogre::AtomicObject< T >::mField, and OGRE_LOCK_AUTO_MUTEX.

## Member Data Documentation

template<class T>

OGRE_AUTO_MUTEX volatile T Ogre::AtomicObject< T >::mField `[protected]`

Definition at line 100 of file OgreAtomicWrappers.h.

Referenced by Ogre::AtomicObject< T >::cas(), Ogre::AtomicObject< T >::get(), Ogre::AtomicObject< T >::operator++(), Ogre::AtomicObject< T >::operator--(), and Ogre::AtomicObject< T >::set().

The documentation for this class was generated from the following file:

- OgreAtomicWrappers.h

Copyright © 2008 Torus Knot Software Ltd
This work is licensed under a Creative Commons Attribution-ShareAlike 2.5 License.
Last modified Sun Jul 26 11:32:46 2009